#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <libporty/net/network.h>
#include "driver.h"
#include "test_common.h"

const char *user_search[] = {"tcurses_termcap", NULL};
extern const char **tcurses_cap_search_user;

#define exec0(name) \
do { \
	char buff[256]; \
	int len; \
	len = tcurses_drv_ ## name (drv, buff); \
	if (len > 0) \
		fwrite(buff, len, 1, stdout); \
} while(0)

#define exec1(name) \
do { \
	char buff[256]; \
	int len; \
	exec_setup(1); \
	len = tcurses_drv_ ## name (drv, buff, a[0]); \
	if (len > 0) \
		fwrite(buff, len, 1, stdout); \
} while(0)

#define exec2(name) \
do { \
	char buff[256]; \
	int len; \
	exec_setup(2); \
	len = tcurses_drv_ ## name (drv, buff, a[0], a[1]); \
	if (len > 0) \
		fwrite(buff, len, 1, stdout); \
} while(0)


#define exec3(name) \
do { \
	char buff[256]; \
	int len; \
	exec_setup(3); \
	len = tcurses_drv_ ## name (drv, buff, a[0], a[1], a[2]); \
	if (len > 0) \
		fwrite(buff, len, 1, stdout); \
} while(0)


int main(int argc, char *argv[])
{
	FILE *f = stdin;
	tcurses_drv_t *drv = NULL;
	char *end, *cmd, *args, line[1024];

	tcurses_cap_search_user = user_search;

	while(!(feof(f))) {
		*line = '\0';
		fgets(line, sizeof(line), f);
		cmd = line;
		while(isspace(*cmd)) cmd++;
		end = strpbrk(cmd, "\r\n");
		if (end != '\0')
			*end = '\0';
		args = strpbrk(cmd, " \t");
		if (args != NULL) {
			*args = '\0';;
			args++;
		}
		if (strcmp(cmd, "init") == 0) {
			drv = tcurses_drv_init(args);
			if (drv == NULL) {
				fprintf(stderr, "ERROR: can't initialize '%s'\n", args);
				exit(1);
			}
		}
		else if (strcmp(cmd, "print") == 0)
			printf("%s", args);
		else if (strcmp(cmd, "reset") == 0)
			exec0(reset);
		else if (strcmp(cmd, "clear") == 0)
			exec0(clear);
		else if (strcmp(cmd, "home") == 0)
			exec0(home);
		else if (strcmp(cmd, "gotoxy") == 0)
			exec2(gotoxy);
		else if (strcmp(cmd, "getxy") == 0) {
			int len;
			char buff[32];
			exec0(getxy);
			len = fread(buff, 1, sizeof(buff), stdin);
			printf("result: %d\n", len);
		}
		else if (strcmp(cmd, "incx") == 0)
			exec1(incx);
		else if (strcmp(cmd, "setfg") == 0)
			exec1(setfg);
		else if (strcmp(cmd, "setbg") == 0)
			exec1(setbg);
		else if (strcmp(cmd, "seta") == 0)
			exec1(seta);
		else if (strcmp(cmd, "setattr") == 0)
			exec3(setattr);
	}
	return 0;
}
