#!/bin/sh

if test -z "$fgwirc"
then
	fgwirc=fgwirc
fi

actlist()
{
echo '
win new
win log on actlist.txt
echo ---actlist on---
actlist
exit
' > rc.actlist
$fgwirc -c rc.actlist > /dev/null
awk '
(copy) { $1=""; line = $0; sub("^ *", "", line); gsub(" ", "\n", line); print line }
/---actlist on---/ { copy = 1 }
' < actlist.txt

rm rc.actlist actlist.txt 
}

details()
{
	actlist | awk '
		BEGIN {
			print "win new"
			print "win log on actdetail.txt"
		}
		{
			print "echo ---actlist: " $1
			print "help " $1
		}
		END {
			print "exit"
		}
	' > rc.actdetail
	$fgwirc -c rc.actdetail > /dev/null
	awk '
		/---actlist:/ { copy = 1 }
		(copy) { $1=""; print $0 }
	' < actdetail.txt
	rm rc.actdetail actdetail.txt
}

gen_html()
{
echo '<html><body>
<h1> Fgwirc builtin actions </h1>'
	details | awk '
		BEGIN { q = "\"" }
		/---actlist:/ {
			act = $2;
			print ""
			print "<h2 id=" q act q ">" act "</h2>"
			next
		}

		/--- help end ---/ { copy=0; print "</pre>"; next }

		(copy)  {
			line = $0
			gsub("&", "\\&amp;", line)
			gsub("<", "\\&lt;", line)
			gsub(">", "\\&gt;", line)
			print line
		}

		/--- help begin ---/ { copy=1; print "<pre>"; next }

	'
}

case "$1" in
	"") actlist ;;
	details) details ;;
	html) gen_html ;;
	*) echo "Unknown mode of operation: $1" >&2; exit 1 ;;
esac

